--- a/TAs Fri Dec 07 12:17:27 2018 +0000
+++ b/TAs Sun Dec 09 01:36:49 2018 +0000
@@ -40,6 +40,23 @@
233 submissions
+=======================
+Ninos Lahdo used var instead of val, but in useless places
+Name: Ninos Lahdo
+K-number: K1764081
+Student Number: 1706056
+GitHub username: NsL01
+GitHub profile link: https://github.com/NsL01
+
+
+========================
+if(nullable(p) == true) ...
+
+check assignment20189-NaharulHayat when marking
+========================
+
+
+
2017 RESULTS
--- /dev/null Thu Jan 01 00:00:00 1970 +0000
+++ b/marking1/tails Sun Dec 09 01:36:49 2018 +0000
@@ -0,0 +1,15 @@
+#!/bin/sh
+###set -e
+
+trap "exit" INT
+
+files=${1:-assignment20177-*}
+
+for sd in $files; do
+ cd $sd
+ #echo $sd
+ tail -1 output
+ cd ..
+done
+
+
--- /dev/null Thu Jan 01 00:00:00 1970 +0000
+++ b/marking3/knight1_test.sh Sun Dec 09 01:36:49 2018 +0000
@@ -0,0 +1,185 @@
+#!/bin/bash
+
+# to make the script fail safely
+set -euo pipefail
+
+out=${1:-output}
+
+echo "" > $out
+
+echo "Below is the feedback and provisional marks for your submission" >> $out
+echo "for assignment 8 Part 1. Please note all marks are provisional until" >> $out
+echo "ratified by the assessment board -- this is not an official" >> $out
+echo "results transcript." >> $out
+echo "" >> $out
+
+
+
+# marks for CW8 part 1
+marks=$(( 0 ))
+
+
+# compilation tests (used to be 30 secs)
+
+function scala_compile {
+ (ulimit -t 30; JAVA_OPTS="-Xmx1g" scala "$1" 2> /dev/null 1> /dev/null)
+}
+
+# functional tests
+
+function scala_assert {
+ (ulimit -t 30; JAVA_OPTS="-Xmx1g" scala -nc -i "$1" "$2" -e "" 2> /dev/null 1> /dev/null)
+}
+
+# purity test
+
+function scala_vars {
+ (egrep '\bvar\b|\breturn\b|\.par|ListBuffer|mutable|new Array' "$1" 2> /dev/null 1> /dev/null)
+}
+
+
+# knights1: purity test
+
+echo "knight1.scala does not contain vars, returns, Arrays, ListBuffers etc?" | tee -a $out
+
+if (scala_vars knight1.scala)
+then
+ echo " --> fail" | tee -a $out
+ tsts0=$(( 1 ))
+else
+ echo " --> success" | tee -a $out
+ tsts0=$(( 0 ))
+fi
+
+
+# compilation test
+
+if [ $tsts0 -eq 0 ]
+then
+ echo "knight1.scala runs?" | tee -a $out
+
+ if (scala_compile knight1.scala)
+ then
+ echo " --> success " | tee -a $out
+ tsts1=$(( 0 ))
+ else
+ echo " --> scala did not run knight1.scala" | tee -a $out
+ tsts1=$(( 1 ))
+ fi
+else
+ tsts1=$(( 1 ))
+fi
+
+### knight1 test
+
+if [ $tsts1 -eq 0 ]
+then
+ echo " is_legal(8, Nil, (3, 4)) == true " | tee -a $out
+ echo " is_legal(8, List((4, 1), (1, 0)), (4, 1)) == false " | tee -a $out
+ echo " is_legal(2, Nil, (0, 0)) == true" | tee -a $out
+
+ if (scala_assert "knight1.scala" "knight1_test1.scala")
+ then
+ echo " --> success" | tee -a $out
+ marks=$(( marks + 1 ))
+ else
+ echo " --> test failed" | tee -a $out
+ fi
+fi
+
+### knight2 test
+
+if [ $tsts1 -eq 0 ]
+then
+ echo " legal_moves(8, Nil, (2,2)) == List((3,4), (4,3), (4,1), (3,0), (1,0), (0,1), (0,3), (1,4))" | tee -a $out
+ echo " legal_moves(8, Nil, (7,7)) == List((6,5), (5,6))" | tee -a $out
+ echo " legal_moves(8, List((4,1), (1,0)), (2,2)) == List((3,4), (4,3), (3,0), (0,1), (0,3), (1,4))" | tee -a $out
+ echo " legal_moves(8, List((6,6)), (7,7)) == List((6,5), (5,6))" | tee -a $out
+ echo " legal_moves(1, Nil, (0,0)) == Nil" | tee -a $out
+ echo " legal_moves(2, Nil, (0,0)) == Nil" | tee -a $out
+ echo " legal_moves(3, Nil, (0,0)) == List((1,2), (2,1))" | tee -a $out
+
+ if (scala_assert "knight1.scala" "knight1_test2.scala")
+ then
+ echo " --> success" | tee -a $out
+ marks=$(( marks + 1 ))
+ else
+ echo " --> test failed" | tee -a $out
+ fi
+fi
+
+
+### knight3 test
+
+if [ $tsts1 -eq 0 ]
+then
+ echo " all_tours from every position on the board" | tee -a $out
+ echo " dim = 1: 1" | tee -a $out
+ echo " 2: 0,0,0,0" >> $out
+ echo " 3: 0,0,0,0,0,0,0,0,0" >> $out
+ echo " 4: 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0" | tee -a $out
+ echo " 5: 304,0,56,0,304,0,56,0,56,0,56,0,64,0,56,0,56,0,56,0,304,0,56,0,304" | tee -a $out
+
+ if (scala_assert "knight1.scala" "knight1_test3a.scala")
+ then
+ echo " --> success" | tee -a $out
+ marks=$(( marks + 1 ))
+ else
+ echo " --> test failed" | tee -a $out
+ fi
+fi
+
+if [ $tsts1 -eq 0 ]
+then
+ echo " enum_tours(5, List((0,2)) ) => 56 tours? and all correct?" | tee -a $out
+
+ if (scala_assert "knight1.scala" "knight1_test3b.scala")
+ then
+ echo " --> success" | tee -a $out
+ marks=$(( marks + 1 ))
+ else
+ echo " --> test failed" | tee -a $out
+ fi
+fi
+
+
+### knight2a test
+
+if [ $tsts1 -eq 0 ]
+then
+ echo " val f = (x:(Int, Int)) => if (x._1 > 3) Some(List(x)) else None " | tee -a $out
+ echo " first(List((1,0),(2,0),(3,0),(4,0)), f) == Some(List((4,0)))" | tee -a $out
+ echo " first(List((1,0),(2,0),(3,0)), f) == None" | tee -a $out
+
+ if (scala_assert "knight1.scala" "knight1_test4.scala")
+ then
+ echo " --> success" | tee -a $out
+ marks=$(( marks + 1 ))
+ else
+ echo " --> test failed" | tee -a $out
+ fi
+fi
+
+
+### knight2b test
+
+if [ $tsts1 -eq 0 ]
+then
+ echo " is first_tour(8, List((0, 0))) ok? " | tee -a $out
+ echo " is first_tour(4, List((0, 0))) == None " | tee -a $out
+
+ if (scala_assert "knight1.scala" "knight5_test.scala")
+ then
+ echo " --> success" | tee -a $out
+ marks=$(( marks + 2 ))
+ else
+ echo " --> test failed" | tee -a $out
+ fi
+fi
+
+
+## final marks
+echo "Overall mark for Part 1" | tee -a $out
+echo "$marks" | tee -a $out
+
+
--- /dev/null Thu Jan 01 00:00:00 1970 +0000
+++ b/marking3/knight1_test1.scala Sun Dec 09 01:36:49 2018 +0000
@@ -0,0 +1,6 @@
+
+assert(is_legal(8, Nil, (3, 4)) == true)
+assert(is_legal(8, List((4, 1), (1, 0)), (4, 1)) == false)
+assert(is_legal(2, Nil, (0, 0)) == true)
+
+
--- /dev/null Thu Jan 01 00:00:00 1970 +0000
+++ b/marking3/knight1_test2.scala Sun Dec 09 01:36:49 2018 +0000
@@ -0,0 +1,11 @@
+
+assert(legal_moves(8, Nil, (2,2)) ==
+ List((3,4), (4,3), (4,1), (3,0), (1,0), (0,1), (0,3), (1,4)))
+assert(legal_moves(8, Nil, (7,7)) == List((6,5), (5,6)))
+assert(legal_moves(8, List((4,1), (1,0)), (2,2)) ==
+ List((3,4), (4,3), (3,0), (0,1), (0,3), (1,4)))
+assert(legal_moves(8, List((6,6)), (7,7)) == List((6,5), (5,6)))
+assert(legal_moves(1, Nil, (0,0)) == Nil)
+assert(legal_moves(2, Nil, (0,0)) == Nil)
+assert(legal_moves(3, Nil, (0,0)) == List((1,2), (2,1)))
+
--- /dev/null Thu Jan 01 00:00:00 1970 +0000
+++ b/marking3/knight1_test3a.scala Sun Dec 09 01:36:49 2018 +0000
@@ -0,0 +1,36 @@
+
+type Pos = (Int, Int) // a position on a chessboard
+type Path = List[Pos] // a path...a list of positions
+
+def count_all_tours_urban(dim: Int) = {
+ for (i <- (0 until dim).toList;
+ j <- (0 until dim).toList) yield count_tours(dim, List((i, j)))
+}
+
+def add_pair_urban(x: Pos)(y: Pos): Pos =
+ (x._1 + y._1, x._2 + y._2)
+
+def is_legal_urban(dim: Int, path: Path)(x: Pos): Boolean =
+ 0 <= x._1 && 0 <= x._2 && x._1 < dim && x._2 < dim && !path.contains(x)
+
+def moves_urban(x: Pos): List[Pos] =
+ List(( 1, 2),( 2, 1),( 2, -1),( 1, -2),
+ (-1, -2),(-2, -1),(-2, 1),(-1, 2)).map(add_pair_urban(x))
+
+def legal_moves_urban(dim: Int, path: Path, x: Pos): List[Pos] =
+ moves_urban(x).filter(is_legal_urban(dim, path))
+
+def correct_urban(dim: Int)(p: Path): Boolean = p match {
+ case Nil => true
+ case x::Nil => true
+ case x::y::p => if (legal_moves_urban(dim, p, y).contains(x)) correct_urban(dim)(y::p) else false
+}
+
+
+
+assert(count_all_tours_urban(1) == List(1))
+assert(count_all_tours_urban(2) == List(0, 0, 0, 0))
+assert(count_all_tours_urban(3) == List(0, 0, 0, 0, 0, 0, 0, 0, 0))
+assert(count_all_tours_urban(4) == List(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0))
+assert(count_all_tours_urban(5) == List(304, 0, 56, 0, 304, 0, 56, 0, 56, 0, 56, 0, 64, 0, 56, 0, 56, 0, 56, 0, 304, 0, 56, 0, 304))
+
--- /dev/null Thu Jan 01 00:00:00 1970 +0000
+++ b/marking3/knight1_test3b.scala Sun Dec 09 01:36:49 2018 +0000
@@ -0,0 +1,33 @@
+
+type Pos = (Int, Int) // a position on a chessboard
+type Path = List[Pos] // a path...a list of positions
+
+def count_all_tours_urban(dim: Int) = {
+ for (i <- (0 until dim).toList;
+ j <- (0 until dim).toList) yield count_tours(dim, List((i, j)))
+}
+
+def add_pair_urban(x: Pos)(y: Pos): Pos =
+ (x._1 + y._1, x._2 + y._2)
+
+def is_legal_urban(dim: Int, path: Path)(x: Pos): Boolean =
+ 0 <= x._1 && 0 <= x._2 && x._1 < dim && x._2 < dim && !path.contains(x)
+
+def moves_urban(x: Pos): List[Pos] =
+ List(( 1, 2),( 2, 1),( 2, -1),( 1, -2),
+ (-1, -2),(-2, -1),(-2, 1),(-1, 2)).map(add_pair_urban(x))
+
+def legal_moves_urban(dim: Int, path: Path, x: Pos): List[Pos] =
+ moves_urban(x).filter(is_legal_urban(dim, path))
+
+def correct_urban(dim: Int)(p: Path): Boolean = p match {
+ case Nil => true
+ case x::Nil => true
+ case x::y::p => if (legal_moves_urban(dim, p, y).contains(x)) correct_urban(dim)(y::p) else false
+}
+
+
+
+val ts_urban = enum_tours(5, List((0, 2)))
+assert(ts_urban.map(correct_urban(5)).forall(_ == true) == true)
+assert(ts_urban.length == 56)
--- /dev/null Thu Jan 01 00:00:00 1970 +0000
+++ b/marking3/knight1_test4.scala Sun Dec 09 01:36:49 2018 +0000
@@ -0,0 +1,5 @@
+
+val f = (x:(Int, Int)) => if (x._1 > 3) Some(List(x)) else None
+
+assert(CW7b.first(List((1,0),(2,0),(3,0),(4,0)), f) == Some(List((4,0))))
+assert(CW7b.first(List((1,0),(2,0),(3,0)), f) == None)
--- /dev/null Thu Jan 01 00:00:00 1970 +0000
+++ b/marking3/knight1_test5.scala Sun Dec 09 01:36:49 2018 +0000
@@ -0,0 +1,30 @@
+
+type Pos = (Int, Int) // a position on a chessboard
+type Path = List[Pos] // a path...a list of positions
+
+def add_pair_urban(x: Pos)(y: Pos): Pos =
+ (x._1 + y._1, x._2 + y._2)
+
+def is_legal_urban(dim: Int, path: Path)(x: Pos): Boolean =
+ 0 <= x._1 && 0 <= x._2 && x._1 < dim && x._2 < dim && !path.contains(x)
+
+def moves_urban(x: Pos): List[Pos] =
+ List(( 1, 2),( 2, 1),( 2, -1),( 1, -2),
+ (-1, -2),(-2, -1),(-2, 1),(-1, 2)).map(add_pair_urban(x))
+
+def legal_moves_urban(dim: Int, path: Path, x: Pos): List[Pos] =
+ moves_urban(x).filter(is_legal_urban(dim, path))
+
+def correct_urban(dim: Int)(p: Path): Boolean = p match {
+ case Nil => true
+ case x::Nil => true
+ case x::y::p =>
+ if (legal_moves_urban(dim, p, y).contains(x)) correct_urban(dim)(y::p) else false
+}
+
+
+val ts1_urban = first_tour(8, List((0, 0))).get
+assert(correct_urban(8)(ts1_urban) == true)
+
+val ts2_urban = first_tour(4, List((0, 0)))
+assert(ts2_urban == None)
--- /dev/null Thu Jan 01 00:00:00 1970 +0000
+++ b/marking3/knight3_test.sh Sun Dec 09 01:36:49 2018 +0000
@@ -0,0 +1,124 @@
+#!/bin/bash
+
+# to make the script fail safely
+set -euo pipefail
+
+
+out=${1:-output}
+
+echo "" > $out
+
+echo "Below is the feedback and provisional marks for your submission" >> $out
+echo "for assignment 7 Part 2. Please note all marks are provisional until" >> $out
+echo "ratified by the assessment board -- this is not an official" >> $out
+echo "results transcript." >> $out
+echo "" >> $out
+
+# marks for CW7 part 2
+marks=$(( 0 ))
+
+# compilation tests
+
+function scala_compile {
+ (ulimit -t 360; JAVA_OPTS="-Xmx1g" scala "$1" 2> /dev/null 1> /dev/null)
+}
+
+# functional tests
+
+function scala_assert {
+ (ulimit -t 360; JAVA_OPTS="-Xmx4g -Xss200m" scala -i "$1" "$2" -e "" 2> /dev/null 1> /dev/null)
+}
+
+
+# purity test
+
+function scala_vars {
+ (egrep '\bvar\b|\breturn\b|\.par|ListBuffer|mutable|new Array' "$1" 2> /dev/null 1> /dev/null)
+}
+
+
+# knights3: purity test
+#
+echo "knight3.scala does not contain vars, returns, Arrays, ListBuffers etc?" | tee -a $out
+
+
+if (scala_vars knight3.scala)
+then
+ echo " --> test failed" | tee -a $out
+ tsts0=$(( 1 ))
+else
+ echo " --> success" | tee -a $out
+ tsts0=$(( 0 ))
+fi
+
+
+# compilation test
+if [ $tsts0 -eq 0 ]
+then
+ echo "knight3.scala runs?" | tee -a $out
+
+ if (scala_compile knight3.scala)
+ then
+ echo " --> success" | tee -a $out
+ tsts1=$(( 0 ))
+ else
+ echo " --> scala knight3.scala did not run successfully" | tee -a $out
+ tsts1=$(( 1 ))
+ fi
+else
+ tsts1=$(( 1 ))
+fi
+
+# ordered move test
+
+if [ $tsts1 -eq 0 ]
+then
+ echo " ordered_moves(8, List((3,4), (3,2)), (1,3)) == List((0,1), (0,5), (2,1), (2,5))" | tee -a $out
+ echo " ordered_moves(8, List((4,0)), (0,0)) == List((2,1), (1,2))" | tee -a $out
+ echo " ordered_moves(8, List((0,4)), (0,0)) == List((1,2), (2,1))" | tee -a $out
+
+ if (scala_assert "knight3.scala" "knight3a_test.scala")
+ then
+ echo " --> success" | tee -a $out
+ marks=$(( marks + 1 ))
+ else
+ echo " --> test failed" | tee -a $out
+ fi
+fi
+
+
+# first-closed-tour test
+
+if [ $tsts1 -eq 0 ]
+then
+ echo " first_closed_tour_heuristic(6, List((3,3))) found and correct?" | tee -a $out
+
+ if (scala_assert "knight3.scala" "knight3b_test.scala")
+ then
+ echo " --> success" | tee -a $out
+ marks=$(( marks + 1 ))
+ else
+ echo " --> test failed" | tee -a $out
+ fi
+fi
+
+
+
+if [ $tsts1 -eq 0 ]
+then
+ echo " first_tour_heuristic(8, List((0,0))) found and correct?" | tee -a $out
+ echo " first_tour_heuristic(40, List((0,0))) found and correct?" | tee -a $out
+
+ if (scala_assert "knight3.scala" "knight3c_test.scala")
+ then
+ echo " --> success" | tee -a $out
+ marks=$(( marks + 1 ))
+ else
+ echo " --> test failed" | tee -a $out
+ fi
+fi
+
+
+## final marks
+echo "Overall mark for CW 7, Part 2" | tee -a $out
+echo "$marks" | tee -a $out
--- /dev/null Thu Jan 01 00:00:00 1970 +0000
+++ b/marking3/knight3a_test.scala Sun Dec 09 01:36:49 2018 +0000
@@ -0,0 +1,5 @@
+
+assert(CW7c.ordered_moves(8, List((3,4), (3,2)), (1,3)) == List((0,1), (0,5), (2,1), (2,5)))
+assert(CW7c.ordered_moves(8, List((4,0)), (0,0)) == List((2,1), (1,2)))
+assert(CW7c.ordered_moves(8, List((0,4)), (0,0)) == List((1,2), (2,1)))
+
--- /dev/null Thu Jan 01 00:00:00 1970 +0000
+++ b/marking3/knight3b_test.scala Sun Dec 09 01:36:49 2018 +0000
@@ -0,0 +1,40 @@
+
+//import scala.concurrent._
+//import scala.concurrent.duration._
+//import ExecutionContext.Implicits.global
+//import scala.language.postfixOps
+
+type Pos = (Int, Int)
+type Path = List[Pos]
+
+def add_pair_urban(x: Pos)(y: Pos): Pos =
+ (x._1 + y._1, x._2 + y._2)
+
+def is_legal_urban(dim: Int, path: Path)(x: Pos): Boolean =
+ 0 <= x._1 && 0 <= x._2 && x._1 < dim && x._2 < dim && !path.contains(x)
+
+def moves_urban(x: Pos): List[Pos] =
+ List(( 1, 2),( 2, 1),( 2, -1),( 1, -2),
+ (-1, -2),(-2, -1),(-2, 1),(-1, 2)).map(add_pair_urban(x))
+
+def legal_moves_urban(dim: Int, path: Path, x: Pos): List[Pos] =
+ moves_urban(x).filter(is_legal_urban(dim, path))
+
+def correct_urban(dim: Int)(p: Path): Boolean = p match {
+ case Nil => true
+ case x::Nil => true
+ case x::y::p =>
+ if (legal_moves_urban(dim, p, y).contains(x)) correct_urban(dim)(y::p) else false
+}
+
+def correct_closed_urban(dim: Int)(p: Path) =
+ correct_urban(6)(p) && moves_urban(p.head).contains(p.last)
+
+//lazy val f = Future {
+
+ val tsc = CW7c.first_closed_tour_heuristic(6, List((3, 3))).get
+ assert(correct_closed_urban(6)(tsc) == true)
+
+//}
+
+//Await.result(f, 300 second)
--- /dev/null Thu Jan 01 00:00:00 1970 +0000
+++ b/marking3/knight3c_test.scala Sun Dec 09 01:36:49 2018 +0000
@@ -0,0 +1,50 @@
+
+//import scala.concurrent._
+//import scala.concurrent.duration._
+//import ExecutionContext.Implicits.global
+//import scala.language.postfixOps
+
+println(Runtime.getRuntime.maxMemory)
+
+type Pos = (Int, Int)
+type Path = List[Pos]
+
+def add_pair_urban(x: Pos)(y: Pos): Pos =
+ (x._1 + y._1, x._2 + y._2)
+
+def is_legal_urban(dim: Int, path: Path)(x: Pos): Boolean =
+ 0 <= x._1 && 0 <= x._2 && x._1 < dim && x._2 < dim && !path.contains(x)
+
+def moves_urban(x: Pos): List[Pos] =
+ List(( 1, 2),( 2, 1),( 2, -1),( 1, -2),
+ (-1, -2),(-2, -1),(-2, 1),(-1, 2)).map(add_pair_urban(x))
+
+def legal_moves_urban(dim: Int, path: Path, x: Pos): List[Pos] =
+ moves_urban(x).filter(is_legal_urban(dim, path))
+
+def correct_urban(dim: Int)(p: Path): Boolean = p match {
+ case Nil => true
+ case x::Nil => true
+ case x::y::p =>
+ if (legal_moves_urban(dim, p, y).contains(x)) correct_urban(dim)(y::p) else false
+}
+
+// !!!!!!! the futures need to be removed
+//lazy val f1 = Future {
+
+ val ts8 = CW7c.first_tour_heuristic(8, List((0,0))).get
+ assert(correct_urban(8)(ts8) == true)
+
+//}
+
+//Await.result(f1, 360 second)
+
+
+//lazy val f2 = Future {
+
+ val ts40 = CW7c.first_tour_heuristic(40, List((0,0))).get
+ assert(correct_urban(40)(ts40) == true)
+
+//}
+
+//Await.result(f2, 360 second)
--- /dev/null Thu Jan 01 00:00:00 1970 +0000
+++ b/marking3/mk Sun Dec 09 01:36:49 2018 +0000
@@ -0,0 +1,30 @@
+#!/bin/sh
+###set -e
+
+trap "exit" INT
+
+files=${1:-assignment20188-*}
+
+for sd in $files; do
+ cd $sd
+ echo $sd
+ touch .
+ cp ../../../marking3/knight1_test.sh .
+ cp ../../../marking3/knight1_test1.scala .
+ cp ../../../marking3/knight1_test2.scala .
+ cp ../../../marking3/knight1_test3a.scala .
+ cp ../../../marking3/knight1_test3b.scala .
+ cp ../../../marking3/knight1_test4.scala .
+ cp ../../../marking3/knight1_test5.scala .
+ ./knight1_test.sh output
+ rm knight1_test.sh
+ rm knight1_test1.scala
+ rm knight1_test2.scala
+ rm knight1_test3a.scala
+ rm knight1_test3b.scala
+ rm knight1_test4.scala
+ rm knight1_test5.scala
+ cd ..
+done
+
+
--- /dev/null Thu Jan 01 00:00:00 1970 +0000
+++ b/marking3/mk-advanced Sun Dec 09 01:36:49 2018 +0000
@@ -0,0 +1,24 @@
+#!/bin/sh
+###set -e
+
+trap "exit" INT
+
+files=${1:-assignment20177-*}
+
+for sd in $files; do
+ cd $sd
+ echo $sd
+ touch .
+ cp ../../../marking2/knight3_test.sh .
+ cp ../../../marking2/knight3a_test.scala .
+ cp ../../../marking2/knight3b_test.scala .
+ cp ../../../marking2/knight3c_test.scala .
+ ./knight3_test.sh output
+ rm knight3_test.sh
+ rm knight3a_test.scala
+ rm knight3b_test.scala
+ rm knight3c_test.scala
+ cd ..
+done
+
+
--- a/progs/lecture4.scala Fri Dec 07 12:17:27 2018 +0000
+++ b/progs/lecture4.scala Sun Dec 09 01:36:49 2018 +0000
@@ -209,6 +209,46 @@
+// another example about Fractions
+import scala.language.implicitConversions
+import scala.language.reflectiveCalls
+
+
+case class Fraction(numer: Int, denom: Int) {
+ override def toString = numer.toString + "/" + denom.toString
+
+ def +(other: Fraction) = Fraction(numer + other.numer, denom + other.denom)
+ def /(other: Fraction) = Fraction(numer * other.denom, denom * other.numer)
+ def /% (other: Fraction) = Fraction(numer * other.denom, denom * other.numer)
+
+}
+
+implicit def Int2Fraction(x: Int) = Fraction(x, 1)
+
+
+val half = Fraction(1, 2)
+val third = Fraction (1, 3)
+
+half + third
+half / third
+
+// not sure if one can get this to work
+// properly, since Scala just cannot find out
+// if / is for ints or for Fractions
+(1 / 3) + half
+(1 / 2) + third
+
+// either you have to force the Fraction-type by
+// using a method that is not defined for ints
+(1 /% 3) + half
+(1 /% 2) + third
+
+
+// ...or explicitly give the type in order to allow
+// Scala to do the conversion to Fractions
+((1:Fraction) / 3) + half
+(1 / (3: Fraction)) + half
+
// DFAs in Scala
--- a/testing5/bf_test.sh Fri Dec 07 12:17:27 2018 +0000
+++ b/testing5/bf_test.sh Sun Dec 09 01:36:49 2018 +0000
@@ -94,14 +94,14 @@
if [ $tsts1 -eq 0 ]
then
- echo -e " jumpRight(\"[******]***\", 1, 0) == 8" >> $out
- echo -e " jumpRight(\"[**[*]*]***\", 1, 0) == 8" >> $out
- echo -e " jumpRight(\"[**[*]*]***\", 1, 0) == 8" >> $out
- echo -e " jumpRight(\"[**[***]***\", 1, 0) == 11" >> $out
- echo -e " jumpRight(\"[*[][]*]***\", 1, 0) == 8" >> $out
- echo -e " jumpLeft(\"[******]***\", 6, 0) == 1" >> $out
- echo -e " jumpLeft(\"[******]***\", 7, 0) == -1" >> $out
- echo -e " jumpLeft(\"[*[][]*]***\", 6, 0) == 1" >> $out
+ echo -e " jumpRight(\"[xxxxxx]xxx\", 1, 0) == 8" >> $out
+ echo -e " jumpRight(\"[xx[x]x]xxx\", 1, 0) == 8" >> $out
+ echo -e " jumpRight(\"[xx[x]x]xxx\", 1, 0) == 8" >> $out
+ echo -e " jumpRight(\"[xx[xxx]xxx\", 1, 0) == 11" >> $out
+ echo -e " jumpRight(\"[x[][]x]xxx\", 1, 0) == 8" >> $out
+ echo -e " jumpLeft(\"[xxxxxx]xxx\", 6, 0) == 1" >> $out
+ echo -e " jumpLeft(\"[xxxxxx]xxx\", 7, 0) == -1" >> $out
+ echo -e " jumpLeft(\"[x[][]x]xxx\", 6, 0) == 1" >> $out
if (scala_assert "bf.scala" "bf_test3.scala")
then
--- a/testing5/bf_test3.scala Fri Dec 07 12:17:27 2018 +0000
+++ b/testing5/bf_test3.scala Sun Dec 09 01:36:49 2018 +0000
@@ -1,9 +1,9 @@
-assert(jumpRight("[******]***", 1, 0) == 8)
-assert(jumpRight("[**[*]*]***", 1, 0) == 8)
-assert(jumpRight("[**[*]*]***", 1, 0) == 8)
-assert(jumpRight("[**[***]***", 1, 0) == 11)
-assert(jumpRight("[*[][]*]***", 1, 0) == 8)
-assert(jumpLeft("[******]***", 6, 0) == 1)
-assert(jumpLeft("[******]***", 7, 0) == -1)
-assert(jumpLeft("[*[][]*]***", 6, 0) == 1)
+assert(jumpRight("[xxxxxx]xxx", 1, 0) == 8)
+assert(jumpRight("[xx[x]x]xxx", 1, 0) == 8)
+assert(jumpRight("[xx[x]x]xxx", 1, 0) == 8)
+assert(jumpRight("[xx[xxx]xxx", 1, 0) == 11)
+assert(jumpRight("[x[][]x]xxx", 1, 0) == 8)
+assert(jumpLeft("[xxxxxx]xxx", 6, 0) == 1)
+assert(jumpLeft("[xxxxxx]xxx", 7, 0) == -1)
+assert(jumpLeft("[x[][]x]xxx", 6, 0) == 1)